module Pacman where

import Graphics.Gloss
import Window

type Position = (Float, Float)

-- | cor do Pacman
pacmanColor :: Color
pacmanColor = yellow

-- | Tamanho do Pacman
pacmanRadius :: Float
pacmanRadius = 20

-- | Imagem do Pacman 
mkPlayer :: Position -> Picture
mkPlayer (x, y) = translate x y (pictures [ 
                color black 
                $ circleSolid pacmanRadius,
                color pacmanColor
                $ arcSolid 320 20 pacmanRadius])

-- | Atualiza posição do Pacman
movePacman :: Float -> Position -> Position -> Position
movePacman seconds (x, y) (vx, vy) | rightWallCollision x = (x-5, y)
                                   | leftWallCollision x = (x+5, y)
                                   | otherwise = (x', y')
    where x' = x + vx * seconds
          y' = y + vy * seconds

-- | Verifica se o jogador atingiu a parede da esquerda.
leftWallCollision :: Float -> Bool
leftWallCollision x | x - 25 <= -200 = True
                    | otherwise      = False

-- | Verifica se o jogador atingiu a parede da direita.
rightWallCollision :: Float -> Bool
rightWallCollision x    | x + 20 >=  198  = True
                        | otherwise       = False

-- | Verifica se o jogador atingiu a parede.
paddleWallCollision :: Float -> Bool
paddleWallCollision x = leftWallCollision x || rightWallCollision x