module Testes where

    import Test.QuickCheck
    import Collision
    import Pacman

    -- Distância Euclidiana sempre retorna um valor positivo
    prop_Positividade :: (Float,Float) -> (Float,Float) -> Bool
    prop_Positividade x1 x2 = distanciaEuclidiana x1 x2 >= 0

    -- Distância Euclidiana é permutável e retorna o mesmo valor
    prop_Permutabilidade :: (Float,Float) -> (Float,Float) -> Bool
    prop_Permutabilidade x1 x2 = distanciaEuclidiana x1 x2 == distanciaEuclidiana x2 x1

    -- Equação que move o Pacman é nula (não realiza alteração no valor) se a velocidade é nula
    prop_Nulidade :: Float -> Position -> Bool
    prop_Nulidade sec x1 = movePacman sec x1 (0,0) == x1